//	Copyright (c) 1998-2011 BCGSoft Co Ltd. 
//	All rights reserved.
//	Visit us:	http://www.bcgsoft.com
//	E-mail: 	mailto:info@bcgsoft.com
//
//	Please, read the text in comments.
//	It explains how to see various features in action
//	Note to improved noticeable syntax coloring

#include "stdafx.h"         // To set or remove a bookmark at the currnet line 
                            // use 'Toggle Bookmark' ('Ctrl'+'F2')
#include <windows.h>
#include <stdio.h>          // To move the cursor between bookmarks
#include <conio.h>          // use 'Next Bookmark' and 'Previous Bookmark'

#define DO_TRACE(bTrace, lpszText)  { if (bTrace) { printf("%s\n",lpszText); } }
							// Use drag-and-drop editing
class CMyClass
{                           // To find the text string use 'Find' ('Ctrl'+'F')
public:						// Use 'F3', 'Shift'+'F3' hotkeys to find next or previous text entry
    CMyClass(): m_bTrace(FALSE)
    {						// To indent text select several lines press 'Tab' button
        memset(&m_lf,0,sizeof(LOGFONT));
    }						// Use 'Ctrl+Right' and 'Ctrl+Left' to navigate
    ~CMyClass()				// through sections of code by matching group delimiters
    {
        OnDestroy();		// To insert or remove a breakpoint click
    }						// use 'Insert/Remove Breakpoint' ('F9')
    int DoMain()
    {
        DO_TRACE(m_bTrace,"CMyClass::DoMain ()");
        return 0;
    }						// Change font style, size, and default color
    const char* GetAppName() const  { return "Example.exe"; }
    inline void EnableTrace(BOOL bTrace = TRUE)  { m_bTrace = bTrace; }

protected:
            BOOL m_bTrace;
            LOGFONT m_lf;

            virtual void OnDestroy()
            {               // Move mouse over the symbol to view its definition
                DO_TRACE(m_bTrace, "CMyClass::OnDestroy ()");
            }               // Type "this->" to open class members' popup list
};

int main()
//	The entry point for the console application
{
    CMyClass* pMyClass = new CMyClass();    //  To find out the class/struct
                                            //  members' names simple strike '.'
    DO_TRACE(TRUE, pMyClass->GetAppName()); //  after typing its name or just
    int nRet = pMyClass->DoMain();          //  press 'Ctrl'+'Alt'+'T'
    
    delete pMyClass;                        //  To find out the CMyClass->m_lf members'
                                            //  names type "pMyClass->m_lf." to open
    return nRet;                            //  class members' popup list
}
