// OutlineDemoView.cpp : implementation of the COutlineDemoView class
//

#include "stdafx.h"
#include "OutlineDemo.h"

#include "OutlineDemoDoc.h"
#include "OutlineDemoView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutlineDemoView

IMPLEMENT_DYNCREATE(COutlineDemoView, CBCGPEditView)

BEGIN_MESSAGE_MAP(COutlineDemoView, CBCGPEditView)
	//{{AFX_MSG_MAP(COutlineDemoView)
	ON_WM_CREATE()
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_HIDESELECTION, OnEditHideselection)
	ON_COMMAND(ID_EDIT_STOPHIDINGCURRENT, OnEditStophidingcurrent)
	ON_COMMAND(ID_EDIT_TOGGLEOUTLINING, OnEditToggleoutlining)
	ON_COMMAND(ID_EDIT_TOGGLEALLOUTLINING, OnEditTogglealloutlining)
	ON_COMMAND(ID_EDIT_COLLAPSETODEFINITIONS, OnEditCollapsetodefinitions)
	ON_COMMAND(ID_EDIT_STOPOUTLINING, OnEditStopoutlining)
	ON_UPDATE_COMMAND_UI(ID_EDIT_HIDESELECTION, OnUpdateEditHideselection)
	ON_UPDATE_COMMAND_UI(ID_EDIT_STOPHIDINGCURRENT, OnUpdateEditStophidingcurrent)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TOGGLEOUTLINING, OnUpdateEditToggleoutlining)
	ON_UPDATE_COMMAND_UI(ID_EDIT_TOGGLEALLOUTLINING, OnUpdateEditTogglealloutlining)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COLLAPSETODEFINITIONS, OnUpdateEditCollapsetodefinitions)
	ON_UPDATE_COMMAND_UI(ID_EDIT_STOPOUTLINING, OnUpdateEditStopoutlining)
	ON_COMMAND(ID_EDIT_AUTOOUTLINING, OnEditAutooutlining)
	ON_COMMAND(ID_EDIT_ENABLEOUTLINING, OnEditEnableoutlining)
	ON_COMMAND(ID_EDIT_LINENUMBERS, OnEditLinenumbers)
	ON_UPDATE_COMMAND_UI(ID_EDIT_AUTOOUTLINING, OnUpdateEditAutooutlining)
	ON_UPDATE_COMMAND_UI(ID_EDIT_ENABLEOUTLINING, OnUpdateEditEnableoutlining)
	ON_UPDATE_COMMAND_UI(ID_EDIT_LINENUMBERS, OnUpdateEditLinenumbers)
	//}}AFX_MSG_MAP
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_CURSORPOS, OnUpdateCursorPos)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CBCGPEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CBCGPEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CBCGPEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutlineDemoView construction/destruction

COutlineDemoView::COutlineDemoView()
{
	// TODO: add construction code here

}

COutlineDemoView::~COutlineDemoView()
{
}

BOOL COutlineDemoView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CBCGPEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// COutlineDemoView drawing

void COutlineDemoView::OnDraw(CDC* pDC)
{
	COutlineDemoDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// COutlineDemoView printing

BOOL COutlineDemoView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CBCGPEditView preparation
	return CBCGPEditView::OnPreparePrinting(pInfo);
}

void COutlineDemoView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CBCGPEditView begin printing.
	CBCGPEditView::OnBeginPrinting(pDC, pInfo);
}

void COutlineDemoView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CBCGPEditView end printing
	CBCGPEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// COutlineDemoView diagnostics

#ifdef _DEBUG
void COutlineDemoView::AssertValid() const
{
	CBCGPEditView::AssertValid();
}

void COutlineDemoView::Dump(CDumpContext& dc) const
{
	CBCGPEditView::Dump(dc);
}

COutlineDemoDoc* COutlineDemoView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COutlineDemoDoc)));
	return (COutlineDemoDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COutlineDemoView message handlers

void COutlineDemoView::OnUpdateCursorPos(CCmdUI *pCmdUI)
{
	ASSERT_VALID (GetEditCtrl ());

	CString str;
	str.Format(_T("Ln %i, Col %i"), GetEditCtrl ()->GetCurRow ()+1, GetEditCtrl ()->GetCurColumn ()+1);
	pCmdUI->SetText (str);

	pCmdUI->Enable (); 
}

BOOL COutlineDemoView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	ASSERT_VALID (GetEditCtrl ());
	GetDocument()->SetModifiedFlag(GetEditCtrl ()->IsModified());

	return CBCGPEditView::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

int COutlineDemoView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CBCGPEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// Setting fonts 
	ResetDefaultFont();

	GetEditCtrl ()->EnableToolTips ();

	// Enable outlining
	GetEditCtrl ()->EnableOutlining ();
	GetEditCtrl ()->EnableAutoOutlining ();
	GetEditCtrl ()->SetOutlineMargin ();
	GetEditCtrl ()->SetLineNumbersMargin ();
	GetEditCtrl ()->EnableOutlineParser (FALSE);
	
	return 0;
}

void COutlineDemoView::OnInitialUpdate() 
{
	CBCGPEditView::OnInitialUpdate();
	
	ASSERT_VALID (GetEditCtrl ());

	// Load XML settings for syntax highlighting
	const CString strXMLFileName = _T("bcgpedit-cpp.xml");
	GetEditCtrl ()->LoadXMLSettings(strXMLFileName);
	GetEditCtrl ()->m_bCopyRTFToClipboard = TRUE;

	const CString& strPathName = GetDocument()->GetPathName();
	if (strPathName.IsEmpty())
	{
		RestoreDefaultData();
	}

	GetEditCtrl ()->EnableHyperlinkSupport (FALSE);

	GetEditCtrl ()->EnableOutlineParser (TRUE);
	GetEditCtrl ()->UpdateAutoOutlining ();
}

void COutlineDemoView::ResetDefaultFont()
{
	ASSERT_VALID (GetEditCtrl ());
	
	HFONT hFont = (HFONT)::GetStockObject(DEFAULT_GUI_FONT);
	CDC* pDC = GetDC();

	CFont* pFont = pDC->SelectObject(CFont::FromHandle(hFont));
	pDC->SelectObject(pFont);
	::DeleteObject(hFont);

	LOGFONT lf;
	pFont->GetLogFont (&lf);

	CString strFontName(_T("Courier New"));
	CopyMemory(lf.lfFaceName,(LPCTSTR)strFontName,(strFontName.GetLength() + 1) * sizeof(TCHAR));
	lf.lfWidth = 0;
	lf.lfEscapement = 0;
	lf.lfOrientation = 0;
	lf.lfWeight = FW_NORMAL;
	lf.lfItalic = 0;
	lf.lfUnderline = 0;
	lf.lfStrikeOut = 0;

	m_Font.CreateFontIndirect(&lf);
	GetEditCtrl ()->SetFont (&m_Font);
}

BOOL COutlineDemoView::RestoreDefaultData()
{
	ASSERT_VALID (GetEditCtrl ());

	// Load CPP example
	BOOL bRet = FALSE;
	LPCTSTR lpszResourceName = MAKEINTRESOURCE (ID_EXAMPLE_CPP);
	ASSERT(lpszResourceName != NULL);

	HINSTANCE hInst = AfxFindResourceHandle(lpszResourceName, _T("Examples"));
	HRSRC hRsrc = ::FindResource(hInst, lpszResourceName, _T("Examples"));
	
	if (hRsrc == NULL)
	{
		ASSERT(FALSE);
	}
	else
	{
		HGLOBAL hGlobal = LoadResource(hInst, hRsrc);

		if (hGlobal == NULL)
		{
			ASSERT(FALSE);
		}
		else
		{
			LPSTR lpszText = (LPSTR)LockResource(hGlobal);

			if (lpszText == NULL)
			{
				ASSERT(FALSE);
			}
			else
			{
				USES_CONVERSION;
				GetEditCtrl ()->SetWindowText(A2T(lpszText));
				bRet = TRUE;
			}

			UnlockResource(hGlobal);
			FreeResource(hGlobal);
		}
	}

	return bRet;
}

void COutlineDemoView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	ASSERT_VALID (GetEditCtrl ());

	CMenu menu;
	if (menu.LoadMenu(IDR_CONTEXT_MENU))
	{
		CMenu* pPopup = menu.GetSubMenu(0);
		ASSERT(pPopup != NULL);

		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd());
	}
}

void COutlineDemoView::OnEditHideselection() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->HideSelection ();
}

void COutlineDemoView::OnUpdateEditHideselection(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());

	int nStart = 0;
	int nEnd = 0;
	GetEditCtrl ()->GetSel (nStart, nEnd);

	pCmdUI->Enable (
		nStart >= 0 && nEnd >= 0 && (nStart != nEnd) &&
		GetEditCtrl ()->IsOutliningEnabled () &&
		!GetEditCtrl ()->IsAutoOutliningEnabled ());
}

void COutlineDemoView::OnEditStophidingcurrent() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->StopHidingCurrent ();
}

void COutlineDemoView::OnUpdateEditStophidingcurrent(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->Enable (
		GetEditCtrl ()->IsOutliningEnabled () &&
		!GetEditCtrl ()->IsAutoOutliningEnabled ());
}

void COutlineDemoView::OnEditToggleoutlining() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->ToggleOutlining ();
}

void COutlineDemoView::OnUpdateEditToggleoutlining(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->Enable (GetEditCtrl ()->IsOutliningEnabled ());
}

void COutlineDemoView::OnEditTogglealloutlining() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->ToggleAllOutlining ();
}

void COutlineDemoView::OnUpdateEditTogglealloutlining(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->Enable (GetEditCtrl ()->IsOutliningEnabled ());
}

void COutlineDemoView::OnEditCollapsetodefinitions() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->CollapseToDefinitions ();
}

void COutlineDemoView::OnUpdateEditCollapsetodefinitions(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->Enable (GetEditCtrl ()->IsOutliningEnabled ());
}

void COutlineDemoView::OnEditStopoutlining() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->StopOutlining ();
}

void COutlineDemoView::OnUpdateEditStopoutlining(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->Enable (
		GetEditCtrl ()->IsOutliningEnabled () &&
		GetEditCtrl ()->IsAutoOutliningEnabled ());
}

void COutlineDemoView::OnEditAutooutlining() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->EnableAutoOutlining (!GetEditCtrl ()->IsAutoOutliningEnabled ());
	GetEditCtrl ()->UpdateAutoOutlining ();
}

void COutlineDemoView::OnUpdateEditAutooutlining(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->SetCheck (GetEditCtrl ()->IsAutoOutliningEnabled () ? 1 : 0);
	pCmdUI->Enable (GetEditCtrl ()->IsOutliningEnabled ());
}

void COutlineDemoView::OnEditEnableoutlining() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->EnableOutlining (!GetEditCtrl ()->IsOutliningEnabled ());
	GetEditCtrl ()->SetOutlineMargin (GetEditCtrl ()->IsOutliningEnabled ());
	GetEditCtrl ()->UpdateAutoOutlining ();
}

void COutlineDemoView::OnUpdateEditEnableoutlining(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->SetCheck (GetEditCtrl ()->IsOutliningEnabled () ? 1 : 0);
}

void COutlineDemoView::OnEditLinenumbers() 
{
	ASSERT_VALID (GetEditCtrl ());
	GetEditCtrl ()->SetLineNumbersMargin (!GetEditCtrl ()->IsLineNumbersMarginVisible ());
}

void COutlineDemoView::OnUpdateEditLinenumbers(CCmdUI* pCmdUI) 
{
	ASSERT_VALID (GetEditCtrl ());
	pCmdUI->SetCheck (GetEditCtrl ()->IsLineNumbersMarginVisible () ? 1 : 0);
}
